package oopsla.bpmn.diagram.part;

import java.util.List;
import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import java.util.ArrayList;

import oopsla.bpmn.diagram.providers.BpmnElementTypes;

import org.eclipse.gef.palette.PaletteDrawer;

import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

/**
 * @generated
 */
public class BpmnPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createNodes1Group());
		paletteRoot.add(createLinks2Group());
	}

	/**
	 * @generated
	 */
	private PaletteContainer createNodes1Group() {
		PaletteContainer paletteContainer = new PaletteDrawer("Nodes");
		paletteContainer.add(createProcess1CreationTool());
		paletteContainer.add(createPool2CreationTool());
		paletteContainer.add(createStartEvent3CreationTool());
		paletteContainer.add(createEndEvent4CreationTool());
		paletteContainer.add(createIntermediateEvent5CreationTool());
		paletteContainer.add(createTask6CreationTool());
		paletteContainer.add(createDataExclusiveGateway7CreationTool());
		paletteContainer.add(createParallelGateway8CreationTool());
		paletteContainer.add(createDataObject9CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private PaletteContainer createLinks2Group() {
		PaletteContainer paletteContainer = new PaletteDrawer("Links");
		paletteContainer.add(createSequenceFlow1CreationTool());
		paletteContainer.add(createMessageFlow2CreationTool());
		paletteContainer.add(createAssociation3CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createProcess1CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.Process_3001);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.Process_3001);
		ToolEntry result = new NodeToolEntry("Process", "Create new Process",
				smallImage, largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createPool2CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.Pool_2001);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.Pool_2001);
		ToolEntry result = new NodeToolEntry("Pool", "Create new Pool",
				smallImage, largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStartEvent3CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.StartEvent_3003);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.StartEvent_3003);
		ToolEntry result = new NodeToolEntry("StartEvent",
				"Create new StartEvent", smallImage, largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createEndEvent4CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.EndEvent_3004);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.EndEvent_3004);
		ToolEntry result = new NodeToolEntry("EndEvent", "Create new EndEvent",
				smallImage, largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createIntermediateEvent5CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.IntermediateEvent_3008);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.IntermediateEvent_3008);
		ToolEntry result = new NodeToolEntry("IntermediateEvent",
				"Create new IntermediateEvent", smallImage, largeImage,
				elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createTask6CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.Task_3002);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.Task_3002);
		ToolEntry result = new NodeToolEntry("Task", "Create new Task",
				smallImage, largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDataExclusiveGateway7CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.DataExclusiveGateway_3006);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.DataExclusiveGateway_3006);
		ToolEntry result = new NodeToolEntry("DataExclusiveGateway",
				"Create new DataExclusiveGateway", smallImage, largeImage,
				elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createParallelGateway8CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.ParallelGateway_3005);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.ParallelGateway_3005);
		ToolEntry result = new NodeToolEntry("ParallelGateway",
				"Create new ParallelGateway", smallImage, largeImage,
				elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDataObject9CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.DataObject_3007);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(BpmnElementTypes.DataObject_3007);
		ToolEntry result = new NodeToolEntry("DataObject",
				"Create new DataObject", smallImage, largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSequenceFlow1CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.SequenceFlow_4001);

		largeImage = smallImage;

		final List relationshipTypes = new ArrayList();
		relationshipTypes.add(BpmnElementTypes.SequenceFlow_4001);
		ToolEntry result = new LinkToolEntry("SequenceFlow",
				"Create new SequenceFlow", smallImage, largeImage,
				relationshipTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMessageFlow2CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.MessageFlow_4003);

		largeImage = smallImage;

		final List relationshipTypes = new ArrayList();
		relationshipTypes.add(BpmnElementTypes.MessageFlow_4003);
		ToolEntry result = new LinkToolEntry("MessageFlow",
				"Create new MessageFlow", smallImage, largeImage,
				relationshipTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAssociation3CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = BpmnElementTypes
				.getImageDescriptor(BpmnElementTypes.Association_4002);

		largeImage = smallImage;

		final List relationshipTypes = new ArrayList();
		relationshipTypes.add(BpmnElementTypes.Association_4002);
		ToolEntry result = new LinkToolEntry("Association",
				"Create new Association", smallImage, largeImage,
				relationshipTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				ImageDescriptor smallIcon, ImageDescriptor largeIcon,
				List elementTypes) {
			super(title, description, smallIcon, largeIcon);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				ImageDescriptor smallIcon, ImageDescriptor largeIcon,
				List relationshipTypes) {
			super(title, description, smallIcon, largeIcon);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
